VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Keyhook sample from BlackBeltVB.com"
   ClientHeight    =   1170
   ClientLeft      =   1980
   ClientTop       =   1500
   ClientWidth     =   5850
   LinkTopic       =   "Form1"
   ScaleHeight     =   1170
   ScaleWidth      =   5850
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   3000
      TabIndex        =   2
      Text            =   "Text1"
      Top             =   120
      Width           =   2655
   End
   Begin VB.CommandButton Command1 
      Caption         =   "End"
      Height          =   495
      Left            =   3000
      TabIndex        =   0
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Try using the TAB key to switch from the Text box to the Command button, or typing the ~, |, or \ characters."
      Height          =   795
      Index           =   0
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Keyhook sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
' 
' This software is FREEWARE. You may use it as you see fit for 
' your own projects but you may not re-sell the original or the 
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/free/keyhook.htm"
' 
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' This example shows how to use the new Callback capabilities of
' Visual Basic 5.0.  The Keyhook.Bas module contains the Callback
' procedure - KeyboardProc.  The parameters of this Callback are
' specified by the Windows SDK.  This call allows you to intercept keyboard
' messages before they are processed, examining and discarding them if
' need be.
'
' Note that the SDK says that you can pass a NULL for the ThreadID and
' and create a system-wide hook. VB doesn't really support this, however,
' since it's procedures are private and cannot be called outside of the
' current process. That means that a global hook won't work, because other
' processes can't call the hook, but they'll try AND crash.
'
' 7-27-99 - GOOD NEWS! I figured out how to write a system-wide keyboard
' hook DLL in C and look at the returned messages in VB. I'll be writing
' a UserControl and placing it on my UC project page (http://matthart.com/usercontrols).
' This will be similiar to a control I've seen costing $60 plus $500 for
' the source code! And all I'm asking for is $5 to help support my
' UserControls project. I should have the control up in a few days.

Private Sub Command1_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    hHook = SetWindowsHookEx(WH_KEYBOARD, AddressOf KeyboardProc, App.hInstance, App.ThreadID)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim l As Long
    If hHook Then
        l = UnhookWindowsHookEx(hHook)
        hHook = 0
    End If
    End
End Sub
